#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lista.h"


int dodaj(spisak *s, char str[])
{
	unsigned int duz;
	lista novi_slog;
	
	duz = strlen(str);
	novi_slog = (lista) malloc(sizeof(struct cvor_liste));
	novi_slog->sledeci = NULL;
	novi_slog->podatak = (char*) malloc(duz+1);
	
	if (novi_slog->podatak==NULL)
		return 0;
		
	strcpy(novi_slog->podatak, str);

	if (s->kraj==NULL)
		s->pocetak = novi_slog;
	else
		s->kraj->sledeci = novi_slog;
		
	s->kraj = novi_slog;
	s->duzina++;
	
	return 1;
}

int izbaci(spisak *s, char str[])
{
	struct cvor_liste nulti_cvor;
	lista l, naredni;
	
	nulti_cvor.sledeci = s->pocetak;
	l = &nulti_cvor;
	
	for (; (naredni = l->sledeci) != NULL; l = naredni)
	{
		if (strcmp(naredni->podatak, str) == 0)
		{
			lista t;
			
			t = naredni->sledeci;
			free(naredni->podatak);
			free(naredni);
			l->sledeci = t;
			s->pocetak = nulti_cvor.sledeci;
			s->duzina--;
				
			if (t==NULL)
				if (l==&nulti_cvor)
					s->kraj = NULL;
				else
					s->kraj = l;
					
			return 1;
		}
	}
	
	return 0;
}

void ispisi(spisak s)
{
	lista l;
	
	for (l = s.pocetak; l != NULL; l = l->sledeci)
		printf("%s\n", l->podatak);
}

void obrisi(spisak *s)
{
	lista l,t;
	
	for (l = s->pocetak; l != NULL; l = t)
	{
		t = l->sledeci;
		free(l->podatak);
		free(l);
	}
	
	s->pocetak = s->kraj = NULL;
}

void inicijalizuj(spisak *s)
{
	s->pocetak = s->kraj = NULL;
}
